DefinitionBlock("", "SSDT", 2, "hack", "batt", 0)
{
    External(_SB.PCI0, DeviceObj)
    External(_SB.PCI0.LPCB, DeviceObj)
    External(_SB.PCI0.LPCB.EC0, DeviceObj)
    External(_SB.BAT0, DeviceObj)
    External(_SB.WMID, DeviceObj)
    
    External(_SB.PCI0.LPCB.EC0.BFCC, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.MUT0, MutexObj) 
    External(_SB.PCI0.LPCB.EC0.MUT1, MutexObj) 
    External(_SB.PCI0.LPCB.EC0.ECOK, IntObj)
    External(_SB.PCI0.LPCB.EC0.SMRD, MethodObj)
    External(_SB.GBFE, MethodObj)
    External(_SB.ITOS, MethodObj)
    External(_SB.PBFE, MethodObj)
    External(_SB.BRTM, FieldUnitObj)
    External(_SB.BAT0.UPUM, MethodObj)
    External(_SB.BAT0.FABL, IntObj)
    External(_SB.BAT0.PBIF, PkgObj)
    External(_SB.BAT0.PBST, PkgObj)

    External(_SB.PCI0.LPCB.EC0.SMST, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.SMCM, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.SMAD, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.SMPR, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.BCNT, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.MBNH, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.BVLB, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.BVHB, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.SW2S, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.BACR, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.MBST, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.MBTS, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.BTVD, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.MBDC, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.ACCC, FieldUnitObj)
    External(_SB.PCI0.LPCB.EC0.BDVO, FieldUnitObj)
    External(SMB0, FieldUnitObj)


    Method (B1B2, 2, NotSerialized) { Return (Or (Arg0, ShiftLeft (Arg1, 8))) }

    Scope (_SB.PCI0.LPCB)
    {
        Scope (EC0)
        {
            OperationRegion (ERAX, EmbeddedControl, Zero, 0xFF)
            
            Field (ERAX, ByteAcc, Lock, Preserve)
            {
                Offset (0x04),
                SD00,   8, 
                SD01,   8, 
                SD02,   8, 
                SD03,   8, 
                SD04,   8, 
                SD05,   8, 
                SD06,   8, 
                SD07,   8, 
                SD08,   8, 
                SD09,   8, 
                SD0A,   8, 
                SD0B,   8, 
                SD0C,   8, 
                SD0D,   8, 
                SD0E,   8, 
                SD0F,   8, 
                SD10,   8, 
                SD11,   8, 
                SD12,   8, 
                SD13,   8, 
                SD14,   8, 
                SD15,   8, 
                SD16,   8, 
                SD17,   8, 
                SD18,   8, 
                SD19,   8, 
                SD1A,   8, 
                SD1B,   8, 
                SD1C,   8, 
                SD1D,   8, 
                SD1E,   8, 
                SD1F,   8, 

                Offset (0x70), 
                ADC0,   8,
                ADC1,   8,
                FCC0,   8, 
                FCC1,   8, 
                
                Offset (0x83), 
                CUR0,   8, 
                CUR1,   8, 
                BRM0,   8, 
                BRM1,   8, 
                BCV0,   8, 
                BCV1,   8
            } 
            
            Field (ERAX, ByteAcc, NoLock, Preserve)
            {
                Offset (0x04), 
                SMWX,8,SMWY,8
            }

            Field (ERAX, ByteAcc, NoLock, Preserve)
            {
                Offset (0x04), 
                //FLD0, 64,
                F000,8,F001,8,F002,8,F003,8,
                F004,8,F005,8,F006,8,F007,8

            }

            Field (ERAX, ByteAcc, NoLock, Preserve)
            {
                Offset (0x04), 
                //FLD1, 128,
                F100,8,F101,8,F102,8,F103,8,
                F104,8,F105,8,F106,8,F107,8,
                F108,8,F109,8,F10A,8,F10B,8,
                F10C,8,F10D,8,F10E,8,F10F,8

            }

            Field (ERAX, ByteAcc, NoLock, Preserve)
            {
                Offset (0x04), 
                //FLD2, 192,
                F200,8,F201,8,F202,8,F203,8,
                F204,8,F205,8,F206,8,F207,8,
                F208,8,F209,8,F20A,8,F20B,8,
                F20C,8,F20D,8,F20E,8,F20F,8,
                F210,8,F211,8,F212,8,F213,8,
                F214,8,F215,8,F216,8,F217,8

            }

            Field (ERAX, ByteAcc, NoLock, Preserve)
            {
                Offset (0x04), 
                //FLD3, 256,
                F300,8,F301,8,F302,8,F303,8,
                F304,8,F305,8,F306,8,F307,8,
                F308,8,F309,8,F30A,8,F30B,8,
                F30C,8,F30D,8,F30E,8,F30F,8,
                F310,8,F311,8,F312,8,F313,8,
                F314,8,F315,8,F316,8,F317,8,
                F318,8,F319,8,F31A,8,F31B,8,
                F31C,8,F31D,8,F31E,8,F31F,8
            }

            Method (RFL0, 0, Serialized)
            {
                Name (TEMP, Buffer(0x10) { })
                Store (F000, Index(TEMP, 0x00))
                Store (F001, Index(TEMP, 0x01))
                Store (F002, Index(TEMP, 0x02))
                Store (F003, Index(TEMP, 0x03))
                Store (F004, Index(TEMP, 0x04))
                Store (F005, Index(TEMP, 0x05))
                Store (F006, Index(TEMP, 0x06))
                Store (F007, Index(TEMP, 0x07))
                Return (TEMP)
            }
            /*
            Method (WFL0, 1, Serialized)
            {
                Name (TEMP, Buffer(0x10) { })
                Store (Arg0, TEMP)
                Store (DerefOf(Index(TEMP, 0x00)), F000)
                Store (DerefOf(Index(TEMP, 0x01)), F001)
                Store (DerefOf(Index(TEMP, 0x02)), F002)
                Store (DerefOf(Index(TEMP, 0x03)), F003)
                Store (DerefOf(Index(TEMP, 0x04)), F004)
                Store (DerefOf(Index(TEMP, 0x05)), F005)
                Store (DerefOf(Index(TEMP, 0x06)), F006)
                Store (DerefOf(Index(TEMP, 0x07)), F007)
            }
            */
            
            Method (RFL1, 0, Serialized)
            {
                Name (TEMP, Buffer(0x10) { })
                Store (F100, Index(TEMP, 0x00))
                Store (F101, Index(TEMP, 0x01))
                Store (F102, Index(TEMP, 0x02))
                Store (F103, Index(TEMP, 0x03))
                Store (F104, Index(TEMP, 0x04))
                Store (F105, Index(TEMP, 0x05))
                Store (F106, Index(TEMP, 0x06))
                Store (F107, Index(TEMP, 0x07))
                Store (F108, Index(TEMP, 0x08))
                Store (F109, Index(TEMP, 0x09))
                Store (F10A, Index(TEMP, 0x0A))
                Store (F10B, Index(TEMP, 0x0B))
                Store (F10C, Index(TEMP, 0x0C))
                Store (F10D, Index(TEMP, 0x0D))
                Store (F10E, Index(TEMP, 0x0E))
                Store (F10F, Index(TEMP, 0x0F))
                Return (TEMP)
            }
            /*
            Method (WFL1, 1, Serialized)
            {
                Name (TEMP, Buffer(0x10) { })
                Store (Arg0, TEMP)
                Store (DerefOf(Index(TEMP, 0x00)), F100)
                Store (DerefOf(Index(TEMP, 0x01)), F101)
                Store (DerefOf(Index(TEMP, 0x02)), F102)
                Store (DerefOf(Index(TEMP, 0x03)), F103)
                Store (DerefOf(Index(TEMP, 0x04)), F104)
                Store (DerefOf(Index(TEMP, 0x05)), F105)
                Store (DerefOf(Index(TEMP, 0x06)), F106)
                Store (DerefOf(Index(TEMP, 0x07)), F107)
                Store (DerefOf(Index(TEMP, 0x08)), F108)
                Store (DerefOf(Index(TEMP, 0x09)), F109)
                Store (DerefOf(Index(TEMP, 0x0A)), F10A)
                Store (DerefOf(Index(TEMP, 0x0B)), F10B)
                Store (DerefOf(Index(TEMP, 0x0C)), F10C)
                Store (DerefOf(Index(TEMP, 0x0D)), F10D)
                Store (DerefOf(Index(TEMP, 0x0E)), F10E)
                Store (DerefOf(Index(TEMP, 0x0F)), F10F)
            }
            */

            Method (RFL2, 0, Serialized)
            {
                Name (TEMP, Buffer(0x18) { })
                Store (F200, Index(TEMP, 0x00))
                Store (F201, Index(TEMP, 0x01))
                Store (F202, Index(TEMP, 0x02))
                Store (F203, Index(TEMP, 0x03))
                Store (F204, Index(TEMP, 0x04))
                Store (F205, Index(TEMP, 0x05))
                Store (F206, Index(TEMP, 0x06))
                Store (F207, Index(TEMP, 0x07))
                Store (F208, Index(TEMP, 0x08))
                Store (F209, Index(TEMP, 0x09))
                Store (F20A, Index(TEMP, 0x0A))
                Store (F20B, Index(TEMP, 0x0B))
                Store (F20C, Index(TEMP, 0x0C))
                Store (F20D, Index(TEMP, 0x0D))
                Store (F20E, Index(TEMP, 0x0E))
                Store (F20F, Index(TEMP, 0x0F))
                Store (F210, Index(TEMP, 0x10))
                Store (F211, Index(TEMP, 0x11))
                Store (F212, Index(TEMP, 0x12))
                Store (F213, Index(TEMP, 0x13))
                Store (F214, Index(TEMP, 0x14))
                Store (F215, Index(TEMP, 0x15))
                Store (F216, Index(TEMP, 0x16))
                Store (F217, Index(TEMP, 0x17))
                Return (TEMP)
            }
            /*
            Method (WFL2, 1, Serialized)
            {
                Name (TEMP, Buffer(0x18) { })
                Store (Arg0, TEMP)
                Store (DerefOf(Index(TEMP, 0x00)), F200)
                Store (DerefOf(Index(TEMP, 0x01)), F201)
                Store (DerefOf(Index(TEMP, 0x02)), F202)
                Store (DerefOf(Index(TEMP, 0x03)), F203)
                Store (DerefOf(Index(TEMP, 0x04)), F204)
                Store (DerefOf(Index(TEMP, 0x05)), F205)
                Store (DerefOf(Index(TEMP, 0x06)), F206)
                Store (DerefOf(Index(TEMP, 0x07)), F207)
                Store (DerefOf(Index(TEMP, 0x08)), F208)
                Store (DerefOf(Index(TEMP, 0x09)), F209)
                Store (DerefOf(Index(TEMP, 0x0A)), F20A)
                Store (DerefOf(Index(TEMP, 0x0B)), F20B)
                Store (DerefOf(Index(TEMP, 0x0C)), F20C)
                Store (DerefOf(Index(TEMP, 0x0D)), F20D)
                Store (DerefOf(Index(TEMP, 0x0E)), F20E)
                Store (DerefOf(Index(TEMP, 0x0F)), F20F)
                Store (DerefOf(Index(TEMP, 0x10)), F210)
                Store (DerefOf(Index(TEMP, 0x11)), F211)
                Store (DerefOf(Index(TEMP, 0x12)), F212)
                Store (DerefOf(Index(TEMP, 0x13)), F213)
                Store (DerefOf(Index(TEMP, 0x14)), F214)
                Store (DerefOf(Index(TEMP, 0x15)), F215)
                Store (DerefOf(Index(TEMP, 0x16)), F216)
                Store (DerefOf(Index(TEMP, 0x17)), F217)
            }
            */
            
            Method (RFL3, 0, Serialized)
            {
                Name (TEMP, Buffer(0x20) { })
                Store (F300, Index(TEMP, 0x00))
                Store (F301, Index(TEMP, 0x01))
                Store (F302, Index(TEMP, 0x02))
                Store (F303, Index(TEMP, 0x03))
                Store (F304, Index(TEMP, 0x04))
                Store (F305, Index(TEMP, 0x05))
                Store (F306, Index(TEMP, 0x06))
                Store (F307, Index(TEMP, 0x07))
                Store (F308, Index(TEMP, 0x08))
                Store (F309, Index(TEMP, 0x09))
                Store (F30A, Index(TEMP, 0x0A))
                Store (F30B, Index(TEMP, 0x0B))
                Store (F30C, Index(TEMP, 0x0C))
                Store (F30D, Index(TEMP, 0x0D))
                Store (F30E, Index(TEMP, 0x0E))
                Store (F30F, Index(TEMP, 0x0F))
                Store (F310, Index(TEMP, 0x10))
                Store (F311, Index(TEMP, 0x11))
                Store (F312, Index(TEMP, 0x12))
                Store (F313, Index(TEMP, 0x13))
                Store (F314, Index(TEMP, 0x14))
                Store (F315, Index(TEMP, 0x15))
                Store (F316, Index(TEMP, 0x16))
                Store (F317, Index(TEMP, 0x17))
                Store (F318, Index(TEMP, 0x18))
                Store (F319, Index(TEMP, 0x19))
                Store (F31A, Index(TEMP, 0x1A))
                Store (F31B, Index(TEMP, 0x1B))
                Store (F31C, Index(TEMP, 0x1C))
                Store (F31D, Index(TEMP, 0x1D))
                Store (F31E, Index(TEMP, 0x1E))
                Store (F31F, Index(TEMP, 0x1F))
                Return (TEMP)
            }
            /*
            Method (WFL3, 1, Serialized)
            {
                Name (TEMP, Buffer(0x20) { })
                Store (Arg0, TEMP)
                Store (DerefOf(Index(TEMP, 0x00)), F300)
                Store (DerefOf(Index(TEMP, 0x01)), F301)
                Store (DerefOf(Index(TEMP, 0x02)), F302)
                Store (DerefOf(Index(TEMP, 0x03)), F303)
                Store (DerefOf(Index(TEMP, 0x04)), F304)
                Store (DerefOf(Index(TEMP, 0x05)), F305)
                Store (DerefOf(Index(TEMP, 0x06)), F306)
                Store (DerefOf(Index(TEMP, 0x07)), F307)
                Store (DerefOf(Index(TEMP, 0x08)), F308)
                Store (DerefOf(Index(TEMP, 0x09)), F309)
                Store (DerefOf(Index(TEMP, 0x0A)), F30A)
                Store (DerefOf(Index(TEMP, 0x0B)), F30B)
                Store (DerefOf(Index(TEMP, 0x0C)), F30C)
                Store (DerefOf(Index(TEMP, 0x0D)), F30D)
                Store (DerefOf(Index(TEMP, 0x0E)), F30E)
                Store (DerefOf(Index(TEMP, 0x0F)), F30F)
                Store (DerefOf(Index(TEMP, 0x10)), F310)
                Store (DerefOf(Index(TEMP, 0x11)), F311)
                Store (DerefOf(Index(TEMP, 0x12)), F312)
                Store (DerefOf(Index(TEMP, 0x13)), F313)
                Store (DerefOf(Index(TEMP, 0x14)), F314)
                Store (DerefOf(Index(TEMP, 0x15)), F315)
                Store (DerefOf(Index(TEMP, 0x16)), F316)
                Store (DerefOf(Index(TEMP, 0x17)), F317)
                Store (DerefOf(Index(TEMP, 0x18)), F318)
                Store (DerefOf(Index(TEMP, 0x19)), F319)
                Store (DerefOf(Index(TEMP, 0x1A)), F31A)
                Store (DerefOf(Index(TEMP, 0x1B)), F31B)
                Store (DerefOf(Index(TEMP, 0x1C)), F31C)
                Store (DerefOf(Index(TEMP, 0x1D)), F31D)
                Store (DerefOf(Index(TEMP, 0x1E)), F31E)
                Store (DerefOf(Index(TEMP, 0x1F)), F31F)
            }
            */
               
            Method (RSMD, 0, Serialized)
            {
                Name (TEMP, Buffer (0x20){})
                TEMP [Zero] = SD00 /* \_SB_.PCI0.LPCB.EC0_.SD00 */
                TEMP [One] = SD01 /* \_SB_.PCI0.LPCB.EC0_.SD01 */
                TEMP [0x02] = SD02 /* \_SB_.PCI0.LPCB.EC0_.SD02 */
                TEMP [0x03] = SD03 /* \_SB_.PCI0.LPCB.EC0_.SD03 */
                TEMP [0x04] = SD04 /* \_SB_.PCI0.LPCB.EC0_.SD04 */
                TEMP [0x05] = SD05 /* \_SB_.PCI0.LPCB.EC0_.SD05 */
                TEMP [0x06] = SD06 /* \_SB_.PCI0.LPCB.EC0_.SD06 */
                TEMP [0x07] = SD07 /* \_SB_.PCI0.LPCB.EC0_.SD07 */
                TEMP [0x08] = SD08 /* \_SB_.PCI0.LPCB.EC0_.SD08 */
                TEMP [0x09] = SD09 /* \_SB_.PCI0.LPCB.EC0_.SD09 */
                TEMP [0x0A] = SD0A /* \_SB_.PCI0.LPCB.EC0_.SD0A */
                TEMP [0x0B] = SD0B /* \_SB_.PCI0.LPCB.EC0_.SD0B */
                TEMP [0x0C] = SD0C /* \_SB_.PCI0.LPCB.EC0_.SD0C */
                TEMP [0x0D] = SD0D /* \_SB_.PCI0.LPCB.EC0_.SD0D */
                TEMP [0x0E] = SD0E /* \_SB_.PCI0.LPCB.EC0_.SD0E */
                TEMP [0x0F] = SD0F /* \_SB_.PCI0.LPCB.EC0_.SD0F */
                TEMP [0x10] = SD10 /* \_SB_.PCI0.LPCB.EC0_.SD10 */
                TEMP [0x11] = SD11 /* \_SB_.PCI0.LPCB.EC0_.SD11 */
                TEMP [0x12] = SD12 /* \_SB_.PCI0.LPCB.EC0_.SD12 */
                TEMP [0x13] = SD13 /* \_SB_.PCI0.LPCB.EC0_.SD13 */
                TEMP [0x14] = SD14 /* \_SB_.PCI0.LPCB.EC0_.SD14 */
                TEMP [0x15] = SD15 /* \_SB_.PCI0.LPCB.EC0_.SD15 */
                TEMP [0x16] = SD16 /* \_SB_.PCI0.LPCB.EC0_.SD16 */
                TEMP [0x17] = SD17 /* \_SB_.PCI0.LPCB.EC0_.SD17 */
                TEMP [0x18] = SD18 /* \_SB_.PCI0.LPCB.EC0_.SD18 */
                TEMP [0x19] = SD19 /* \_SB_.PCI0.LPCB.EC0_.SD19 */
                TEMP [0x1A] = SD1A /* \_SB_.PCI0.LPCB.EC0_.SD1A */
                TEMP [0x1B] = SD1B /* \_SB_.PCI0.LPCB.EC0_.SD1B */
                TEMP [0x1C] = SD1C /* \_SB_.PCI0.LPCB.EC0_.SD1C */
                TEMP [0x1D] = SD1D /* \_SB_.PCI0.LPCB.EC0_.SD1D */
                TEMP [0x1E] = SD1E /* \_SB_.PCI0.LPCB.EC0_.SD1E */
                TEMP [0x1F] = SD1F /* \_SB_.PCI0.LPCB.EC0_.SD1F */
                Return (TEMP) /* \_SB_.PCI0.LPCB.EC0_.RSMD.TEMP */
            }

            Method (WSMD, 1, Serialized)
            {
                Name (TEMP, Buffer (0x20){})
                TEMP = Arg0
                SD00 = DerefOf (TEMP [Zero])
                SD01 = DerefOf (TEMP [One])
                SD02 = DerefOf (TEMP [0x02])
                SD03 = DerefOf (TEMP [0x03])
                SD04 = DerefOf (TEMP [0x04])
                SD05 = DerefOf (TEMP [0x05])
                SD06 = DerefOf (TEMP [0x06])
                SD07 = DerefOf (TEMP [0x07])
                SD08 = DerefOf (TEMP [0x08])
                SD09 = DerefOf (TEMP [0x09])
                SD0A = DerefOf (TEMP [0x0A])
                SD0B = DerefOf (TEMP [0x0B])
                SD0C = DerefOf (TEMP [0x0C])
                SD0D = DerefOf (TEMP [0x0D])
                SD0E = DerefOf (TEMP [0x0E])
                SD0F = DerefOf (TEMP [0x0F])
                SD10 = DerefOf (TEMP [0x10])
                SD11 = DerefOf (TEMP [0x11])
                SD12 = DerefOf (TEMP [0x12])
                SD13 = DerefOf (TEMP [0x13])
                SD14 = DerefOf (TEMP [0x14])
                SD15 = DerefOf (TEMP [0x15])
                SD16 = DerefOf (TEMP [0x16])
                SD17 = DerefOf (TEMP [0x17])
                SD18 = DerefOf (TEMP [0x18])
                SD19 = DerefOf (TEMP [0x19])
                SD1A = DerefOf (TEMP [0x1A])
                SD1B = DerefOf (TEMP [0x1B])
                SD1C = DerefOf (TEMP [0x1C])
                SD1D = DerefOf (TEMP [0x1D])
                SD1E = DerefOf (TEMP [0x1E])
                SD1F = DerefOf (TEMP [0x1F])
            }
            
            Method (SMRD, 4, NotSerialized)
            {
                If (!ECOK)
                {
                    Return (0xFF)
                }

                If ((Arg0 != 0x07))
                {
                    If ((Arg0 != 0x09))
                    {
                        If ((Arg0 != 0x0B))
                        {
                            If ((Arg0 != 0x47))
                            {
                                If ((Arg0 != 0xC7))
                                {
                                    Return (0x19)
                                }
                            }
                        }
                    }
                }

                Acquire (MUT0, 0xFFFF)
                Local0 = 0x04
                While ((Local0 > One))
                {
                    SMST &= 0x40
                    SMCM = Arg2
                    SMAD = Arg1
                    SMPR = Arg0
                    Local3 = Zero
                    While (!Local1 = (SMST & 0xBF))
                    {
                        Sleep (0x02)
                        Local3++
                        If ((Local3 == 0x32))
                        {
                            SMST &= 0x40
                            SMCM = Arg2
                            SMAD = Arg1
                            SMPR = Arg0
                            Local3 = Zero
                        }
                    }

                    If ((Local1 == 0x80))
                    {
                        Local0 = Zero
                    }
                    Else
                    {
                        Local0--
                    }
                }

                If (Local0)
                {
                    Local0 = (Local1 & 0x1F)
                }
                Else
                {
                    If ((Arg0 == 0x07))
                    {
                        Arg3 = SMB0 /* \_SB_.PCI0.LPCB.EC0_.SMB0 */
                    }

                    If ((Arg0 == 0x47))
                    {
                        Arg3 = SMB0 /* \_SB_.PCI0.LPCB.EC0_.SMB0 */
                    }

                    If ((Arg0 == 0xC7))
                    {
                        Arg3 = SMB0 /* \_SB_.PCI0.LPCB.EC0_.SMB0 */
                    }

                    If ((Arg0 == 0x09))
                    {
                        Arg3 = B1B2(SMWX,SMWY) /* \_SB_.PCI0.LPCB.EC0_.SMW0 */
                    }

                    If ((Arg0 == 0x0B))
                    {
                        Local3 = BCNT /* \_SB_.PCI0.LPCB.EC0_.BCNT */
                        Local2 = 0x20
                        If ((Local3 > Local2))
                        {
                            Local3 = Local2
                        }

                        If ((Local3 < 0x11))
                        {
                            Local2 = RFL1 /* \_SB_.PCI0.LPCB.EC0_.FLD1 */
                        }
                        ElseIf ((Local3 < 0x19))
                        {
                            Local2 = RFL2 /* \_SB_.PCI0.LPCB.EC0_.FLD2 */
                        }
                        Else
                        {
                            Local2 = RFL3 /* \_SB_.PCI0.LPCB.EC0_.FLD3 */
                        }

                        Local3++
                        Local4 = Buffer (Local3){}
                        Local3--
                        Local5 = Zero
                        Name (OEMS, Buffer (0x46){})
                        ToBuffer (Local2, OEMS) /* \_SB_.PCI0.LPCB.EC0_.SMRD.OEMS */
                        While ((Local3 > Local5))
                        {
                            GBFE (OEMS, Local5, RefOf (Local6))
                            PBFE (Local4, Local5, Local6)
                            Local5++
                        }

                        PBFE (Local4, Local5, Zero)
                        Arg3 = Local4
                    }
                }

                Release (MUT0)
                Return (Local0)
            }

            Method (SMWR, 4, NotSerialized)
            {
                If (!ECOK)
                {
                    Return (0xFF)
                }

                If ((Arg0 != 0x06))
                {
                    If ((Arg0 != 0x08))
                    {
                        If ((Arg0 != 0x0A))
                        {
                            If ((Arg0 != 0x46))
                            {
                                If ((Arg0 != 0xC6))
                                {
                                    Return (0x19)
                                }
                            }
                        }
                    }
                }

                Acquire (MUT0, 0xFFFF)
                Local0 = 0x04
                While ((Local0 > One))
                {
                    If ((Arg0 == 0x06))
                    {
                        SMB0 = Arg3
                    }

                    If ((Arg0 == 0x46))
                    {
                        SMB0 = Arg3
                    }

                    If ((Arg0 == 0xC6))
                    {
                        SMB0 = Arg3
                    }

                    If ((Arg0 == 0x08))
                    {
                        B1B2(SMWX,SMWY) = Arg3
                    }

                    If ((Arg0 == 0x0A))
                    {
                        RSMD() = Arg3
                    }

                    SMST &= 0x40
                    SMCM = Arg2
                    SMAD = Arg1
                    SMPR = Arg0
                    Local3 = Zero
                    While (!Local1 = (SMST & 0xBF))
                    {
                        Sleep (0x02)
                        Local3++
                        If ((Local3 == 0x32))
                        {
                            SMST &= 0x40
                            SMCM = Arg2
                            SMAD = Arg1
                            SMPR = Arg0
                            Local3 = Zero
                        }
                    }

                    If ((Local1 == 0x80))
                    {
                        Local0 = Zero
                    }
                    Else
                    {
                        Local0--
                    }
                }

                If (Local0)
                {
                    Local0 = (Local1 & 0x1F)
                }

                Release (MUT0)
                Return (Local0)
            }
        }
    }
    
    Scope (_SB)
    {
        Scope (BAT0)
        {
            Method (UPBI, 0, NotSerialized)
            {
                Local5 = ^^PCI0.LPCB.EC0.BFCC /* \_SB_.PCI0.LPCB.EC0_.BFCC */
                If ((Local5 && !(Local5 & 0x8000)))
                {
                    Local5 >>= 0x05
                    Local5 <<= 0x05
                    PBIF [One] = Local5
                    PBIF [0x02] = Local5
                    Local2 = (Local5 / 0x64)
                    Local2 += One
                    Local4 = (Local2 * 0x0A)
                    PBIF [0x05] = (Local4 + 0x02)
                    Local4 = (Local2 * 0x05)
                    PBIF [0x06] = (Local4 + 0x02)
                    Local4 = (Local2 * 0x07)
                    FABL = (Local4 + 0x02)
                }

                If (^^PCI0.LPCB.EC0.MBNH)
                {
                    Local0 = ^^PCI0.LPCB.EC0.BVLB /* \_SB_.PCI0.LPCB.EC0_.BVLB */
                    Local1 = ^^PCI0.LPCB.EC0.BVHB /* \_SB_.PCI0.LPCB.EC0_.BVHB */
                    Local1 <<= 0x08
                    Local0 |= Local1
                    PBIF [0x04] = Local0
                    PBIF [0x09] = "OANI$"
                    PBIF [0x0B] = "NiMH"
                }
                Else
                {
                    Local0 = ^^PCI0.LPCB.EC0.BVLB /* \_SB_.PCI0.LPCB.EC0_.BVLB */
                    Local1 = ^^PCI0.LPCB.EC0.BVHB /* \_SB_.PCI0.LPCB.EC0_.BVHB */
                    Local1 <<= 0x08
                    Local0 |= Local1
                    PBIF [0x04] = Local0
                    Sleep (0x32)
                    PBIF [0x0B] = "LION"
                }

                PBIF [0x09] = "Primary"
                UPUM ()
                PBIF [Zero] = One
            }
            
            Method (UPBS, 0, NotSerialized)
            {
                If ((BRTM == One))
                {
                    Local0 = B1B2 (^^PCI0.LPCB.EC0.CUR0, ^^PCI0.LPCB.EC0.CUR1)
                    If ((Local0 & 0x8000))
                    {
                        If ((Local0 == 0xFFFF))
                        {
                            PBST [One] = 0xFFFFFFFF
                        }
                        Else
                        {
                            Local1 = ~Local0
                            Local1++
                            Local3 = (Local1 & 0xFFFF)
                            PBST [One] = Local3
                        }
                    }
                    Else
                    {
                        PBST [One] = Local0
                    }
                }
                Else
                {
                    PBST [One] = 0xFFFFFFFF
                }

                Local5 = B1B2 (^^PCI0.LPCB.EC0.BRM0, ^^PCI0.LPCB.EC0.BRM1)
                If (!(Local5 & 0x8000))
                {
                    Local5 >>= 0x05
                    Local5 <<= 0x05
                    If ((Local5 != DerefOf (PBST [0x02])))
                    {
                        PBST [0x02] = Local5
                    }
                }

                If ((!^^PCI0.LPCB.EC0.SW2S && (^^PCI0.LPCB.EC0.BACR == One)))
                {
                    PBST [0x02] = FABL /* \_SB_.BAT0.FABL */
                }

                PBST [0x03] = B1B2 (^^PCI0.LPCB.EC0.BCV0, ^^PCI0.LPCB.EC0.BCV1)
                PBST [Zero] = ^^PCI0.LPCB.EC0.MBST /* \_SB_.PCI0.LPCB.EC0_.MBST */
            }
        }

        Scope (WMID)
        {
            Method (GBIF, 1, NotSerialized)
            {
                Debug = "HP WMI Command 0x7 (BIOS Read)"
                Acquire (^^PCI0.LPCB.EC0.MUT1, 0xFFFF)
                If (!^^PCI0.LPCB.EC0.ECOK)
                {
                    Local0 = Package (0x02)
                        {
                            0x0D, 
                            Zero
                        }
                    Sleep (0x96)
                    Release (^^PCI0.LPCB.EC0.MUT1)
                    Return (Local0)
                }

                If (Arg0)
                {
                    Local0 = Package (0x02)
                        {
                            0x06, 
                            Zero
                        }
                    Sleep (0x96)
                    Release (^^PCI0.LPCB.EC0.MUT1)
                    Return (Local0)
                }

                If (!^^PCI0.LPCB.EC0.MBTS)
                {
                    Local0 = Package (0x02)
                        {
                            0x34, 
                            Zero
                        }
                    Sleep (0x96)
                    Release (^^PCI0.LPCB.EC0.MUT1)
                    Return (Local0)
                }

                If ((^^PCI0.LPCB.EC0.BTVD != One))
                {
                    Local0 = Package (0x02)
                        {
                            0x37, 
                            Zero
                        }
                    Sleep (0x96)
                    Release (^^PCI0.LPCB.EC0.MUT1)
                    Return (Local0)
                }
                ElseIf (((^^PCI0.LPCB.EC0.MBDC & 0x10) == 0x10))
                {
                    Local0 = Package (0x02)
                        {
                            0x36, 
                            Zero
                        }
                    Sleep (0x96)
                    Release (^^PCI0.LPCB.EC0.MUT1)
                    Return (Local0)
                }

                Local0 = Package (0x03)
                    {
                        Zero, 
                        0x80, 
                        Buffer (0x80){}
                    }
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x18, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [One])
                DerefOf (Local0 [0x02]) [Zero] = Local2
                Local1 = B1B2(^^PCI0.LPCB.EC0.FCC0,^^PCI0.LPCB.EC0.FCC1) /* \_SB_.PCI0.LPCB.EC0_.BFCC */
                Local1 >>= 0x05
                Local1 <<= 0x05
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x03])
                DerefOf (Local0 [0x02]) [0x02] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x0F, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x05])
                DerefOf (Local0 [0x02]) [0x04] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x0C, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x07])
                DerefOf (Local0 [0x02]) [0x06] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x17, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x09])
                DerefOf (Local0 [0x02]) [0x08] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x08, RefOf (Local1))
                Local1 -= 0x0AAA
                Divide (Local1, 0x0A, Local2, Local1)
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x0B])
                DerefOf (Local0 [0x02]) [0x0A] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x09, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x0D])
                DerefOf (Local0 [0x02]) [0x0C] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x0A, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x0F])
                DerefOf (Local0 [0x02]) [0x0E] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x19, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x11])
                DerefOf (Local0 [0x02]) [0x10] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x16, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x13])
                DerefOf (Local0 [0x02]) [0x12] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x3F, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x15])
                DerefOf (Local0 [0x02]) [0x14] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x3E, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x17])
                DerefOf (Local0 [0x02]) [0x16] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x3D, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x19])
                DerefOf (Local0 [0x02]) [0x18] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x3C, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x1B])
                DerefOf (Local0 [0x02]) [0x1A] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x1C, RefOf (Local1))
                Local3 = ITOS (ToBCD (Local1))
                Local2 = 0x1C
                Local4 = Zero
                Local1 = SizeOf (Local3)
                While (Local1)
                {
                    GBFE (Local3, Local4, RefOf (Local5))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local5)
                    Local1--
                    Local2++
                    Local4++
                }

                DerefOf (Local0 [0x02]) [Local2] = 0x20
                Local2++
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x1B, RefOf (Local1))
                Local7 = (Local1 & 0x1F)
                Local6 = ITOS (ToBCD (Local7))
                Local7 = (Local1 & 0x01E0)
                Local7 >>= 0x05
                Local5 = ITOS (ToBCD (Local7))
                Local7 = (Local1 >> 0x09)
                Local7 += 0x07BC
                Local4 = ITOS (ToBCD (Local7))
                Local1 = 0x02
                Local7 = 0x03
                While (Local1)
                {
                    GBFE (Local5, Local7, RefOf (Local3))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local3)
                    Local1--
                    Local2++
                    Local7++
                }

                DerefOf (Local0 [0x02]) [Local2] = "/"
                Local2++
                Local1 = 0x02
                Local7 = 0x03
                While (Local1)
                {
                    GBFE (Local6, Local7, RefOf (Local3))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local3)
                    Local1--
                    Local2++
                    Local7++
                }

                DerefOf (Local0 [0x02]) [Local2] = "/"
                Local2++
                Local1 = 0x04
                Local7 = One
                While (Local1)
                {
                    GBFE (Local4, Local7, RefOf (Local3))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local3)
                    Local1--
                    Local2++
                    Local7++
                }

                DerefOf (Local0 [0x02]) [Local2] = Zero
                ^^PCI0.LPCB.EC0.SMRD (0x0B, 0x16, 0x20, RefOf (Local1))
                Local3 = SizeOf (Local1)
                Local2 = 0x2C
                Local4 = Zero
                While (Local3)
                {
                    GBFE (Local1, Local4, RefOf (Local5))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local5)
                    Local3--
                    Local2++
                    Local4++
                }

                ^^PCI0.LPCB.EC0.SMRD (0x0B, 0x16, 0x70, RefOf (Local1))
                GBFE (Local1, Zero, RefOf (Local5))
                If ((Local5 == 0x36))
                {
                    Local3 = SizeOf (Local1)
                    Local2 = 0x3E
                    Local4 = Zero
                }
                Else
                {
                    Local3 = 0x03
                    Local2 = 0x3E
                    Local4 = Zero
                    Local1 = Buffer (0x04)
                        {
                            "N/A"
                        }
                }

                While (Local3)
                {
                    GBFE (Local1, Local4, RefOf (Local5))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local5)
                    Local3--
                    Local2++
                    Local4++
                }

                ^^PCI0.LPCB.EC0.SMRD (0x0B, 0x16, 0x21, RefOf (Local1))
                Local3 = SizeOf (Local1)
                Local2 = 0x4F
                Local4 = Zero
                While (Local3)
                {
                    GBFE (Local1, Local4, RefOf (Local5))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local5)
                    Local3--
                    Local2++
                    Local4++
                }

                ^^PCI0.LPCB.EC0.SMRD (0x0B, 0x16, 0x22, RefOf (Local1))
                Local3 = SizeOf (Local1)
                Local2 = 0x56
                Local4 = Zero
                While (Local3)
                {
                    GBFE (Local1, Local4, RefOf (Local5))
                    PBFE (DerefOf (Local0 [0x02]), Local2, Local5)
                    Local3--
                    Local2++
                    Local4++
                }

                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, Zero, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x5B])
                DerefOf (Local0 [0x02]) [0x5A] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x1B, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x5D])
                DerefOf (Local0 [0x02]) [0x5C] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x14, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x5F])
                DerefOf (Local0 [0x02]) [0x5E] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x15, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x61])
                DerefOf (Local0 [0x02]) [0x60] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x0B, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x63])
                DerefOf (Local0 [0x02]) [0x62] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x11, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x65])
                DerefOf (Local0 [0x02]) [0x64] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x12, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x67])
                DerefOf (Local0 [0x02]) [0x66] = Local2
                ^^PCI0.LPCB.EC0.SMRD (0x09, 0x16, 0x13, RefOf (Local1))
                Divide (Local1, 0x0100, Local2, DerefOf (Local0 [0x02]) [0x69])
                DerefOf (Local0 [0x02]) [0x68] = Local2
                DerefOf (Local0 [0x02]) [0x6A] = One
                Sleep (0x96)
                Release (^^PCI0.LPCB.EC0.MUT1)
                Return (Local0)
            }
            
            Method (GBCO, 0, Serialized)
            {
                Debug = "HP WMI Command 0x2B (BIOS Read)"
                Local0 = Package (0x03)
                    {
                        Zero, 
                        0x04, 
                        Buffer (0x04){}
                    }
                If ((^^PCI0.LPCB.EC0.ECOK == One))
                {
                    If (^^PCI0.LPCB.EC0.MBTS)
                    {
                        If (^^PCI0.LPCB.EC0.BTVD)
                        {
                            If (^^PCI0.LPCB.EC0.ACCC)
                            {
                                Local2 = ^^PCI0.LPCB.EC0.MBST /* \_SB_.PCI0.LPCB.EC0_.MBST */
                                Local2 &= 0x03
                                Switch (Local2)
                                {
                                    Case (Zero)
                                    {
                                        Local1 = ^^PCI0.LPCB.EC0.BDVO /* \_SB_.PCI0.LPCB.EC0_.BDVO */
                                        If ((Local1 == 0xC5))
                                        {
                                            Local1 = 0x04
                                        }
                                        Else
                                        {
                                            Local1 = Zero
                                        }
                                    }
                                    Case (One)
                                    {
                                        Local1 = 0x02
                                    }
                                    Case (0x02)
                                    {
                                        Local2 = B1B2 (^^PCI0.LPCB.EC0.CUR0, ^^PCI0.LPCB.EC0.CUR1)
                                        Local3 = 0xC3
                                        If (((Local2 <= 0x0200) & (^^PCI0.LPCB.EC0.BDVO == Local3)))
                                        {
                                            Local1 = 0x03
                                        }
                                        Else
                                        {
                                            Local1 = One
                                        }
                                    }
                                    Default
                                    {
                                        DerefOf (Local0 [Zero]) [Zero] = 0x37
                                    }

                                }
                            }
                            Else
                            {
                                Local1 = 0x02
                            }
                        }
                        Else
                        {
                            DerefOf (Local0 [Zero]) [Zero] = 0x37
                        }
                    }
                    Else
                    {
                        Local1 = 0xFF
                    }

                    DerefOf (Local0 [0x02]) [Zero] = Local1
                    DerefOf (Local0 [0x02]) [One] = 0xFF
                }
                Else
                {
                    DerefOf (Local0 [Zero]) [Zero] = 0x35
                }

                Return (Local0)
            }
            
        }     
    }
}